> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.shipbob.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.shipbob.com/_mcp/server.

# Get transactions by invoiceid


GET https://api.shipbob.com/Experimental/invoices/{invoiceId}/transactions

The unique identifier of the invoice whose transactions are to be retrieved

Reference: https://developer.shipbob.com/experimental/api/billing/get-transactions-by-invoiceid

## Authentication

- `Authorization` header (bearer token, required) — Authentication using Personal Access Token (PAT) token
- `Authorization` header (bearer token, required) — OAuth2 authentication using JWT tokens

## Servers

- `https://api.shipbob.com` (https://api.shipbob.com, default)
- `https://sandbox-api.shipbob.com` (https://sandbox-api.shipbob.com)

## Request

### Path parameters

- `invoiceId` (integer, required) — The unique identifier of the invoice whose transactions are to be retrieved Ex:-12345.

### Query parameters

- `cursor` (string, optional) — [Optional] A pagination token used to jump to first, last, next or previous pages. When supplied, it overrides all other filter parameters.
- `pageSize` (integer, optional, default: 100) — Number of transactions to return per page (default is 100, to be entered when API is called for first time). Must be between 1 and 1000.
- `sortOrder` (enum, optional) — Sort order of the results. Valid values: Ascending or Descending (default: Descending).
  - Allowed values: `Ascending`, `Descending`

## Response

### 200

Success

- `first` (string, optional, nullable) — Go to the first page
- `items` (list of object, optional, nullable)
  - `additionalDetails` (map from string to any, optional, nullable) — Any additional details related to the transaction in a key-value pair format.
  - `amount` (double, optional, nullable) — Charge Amount for the transaction
  - `chargeDate` (string, optional, nullable) — The Charge date of transaction
  - `chargeEndDate` (string, optional, nullable) — The end of the billing period for which the charge applies. Null when not applicable.
  - `chargeStartDate` (string, optional, nullable) — The start of the billing period for which the charge applies. Null when not applicable.
  - `currencyCode` (string, optional, nullable) — The ISO currency code (e.g., USD, EUR) for the transaction
  - `fulfillmentCenter` (string, optional, nullable) — The name or code of the fulfillment center involved in the transaction.
  - `invoiceDate` (string, optional, nullable) — The date the invoice was generated
  - `invoiceId` (integer, optional, nullable) — The unique identifier of the related invoice.
  - `invoiceType` (string, optional, nullable) — The type or category of the invoice. Available options: - Shipping - Inbound Fee - WarehouseStorage - AdditionalFee - Return - Credits - BalanceAdjustment - Payment
  - `invoicedStatus` (boolean, optional, nullable) — Indicates whether the transaction has been invoiced.
  - `referenceId` (string, optional, nullable) — A unique reference identifier associated with the transaction
  - `referenceType` (string, optional, nullable) — The type of reference associated with the ReferenceId. Available options: - Shipment - Return - WRO - URO - Ticket Number - FC - LPN Reference - Transfer Plan
  - `taxes` (list of object, optional, nullable) — A list of tax details applied to the transaction if exists.
    - `taxAmount` (double, optional) — Tax amount charged for the tax type.
    - `taxRate` (double, optional) — Rate of Tax charged for the tax type
    - `taxType` (string, optional, nullable) — Type of tax charged for eg. GST
  - `transactionFee` (string, optional, nullable) — The fee type associated with the transaction for eg. Shipping fees To get all the available transaction fees use the endpoint - '/transaction-fees'
  - `transactionId` (string, optional, nullable) — The unique identifier for transaction
  - `transactionSubType` (string, optional, nullable) — The subtype label for the charge (e.g., labor role or packaging type). Null when the transaction has no subtype.
  - `transactionType` (string, optional, nullable) — The classification or nature of the transaction Transaction Types - Charge, Refund, Credit, Payment, BalanceAdjustment
- `last` (string, optional, nullable) — Go to the Last page
- `next` (string, optional, nullable) — Go to the Next page
- `prev` (string, optional, nullable) — Go to the Previous page

## Errors

### 401 Unauthorized Error

Authorization missing or invalid

- `any`

### 403 Forbidden Error

The provided credentials are not authorized to access this resource

- `any`

### 404 Not Found Error

Not Found

- `detail` (string, optional, nullable)
- `instance` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `title` (string, optional, nullable)
- `type` (string, optional, nullable)

### 500 Internal Server Error

Server Error

- `any`

## Examples

**Response**

```json
{
  "first": "f8cUk/xJkbeYp2L8oHqxL2hFiGz3qjre",
  "items": [
    {
      "additionalDetails": {
        "Comment": "TestInvoice"
      },
      "amount": 0.09,
      "chargeDate": "2025-01-01",
      "chargeEndDate": "2025-01-12",
      "chargeStartDate": "2025-01-06",
      "currencyCode": "USD",
      "fulfillmentCenter": "Altona VIC",
      "invoiceDate": "2025-01-01",
      "invoiceId": 12345,
      "invoiceType": "Shipping",
      "invoicedStatus": true,
      "referenceId": "12345",
      "referenceType": "Shipment",
      "taxes": [
        {
          "taxAmount": 0.01,
          "taxRate": 10,
          "taxType": "GST"
        }
      ],
      "transactionFee": "Shipping",
      "transactionId": "01AN4Z07BY79KA1307SR9X4MV3",
      "transactionSubType": "WarehouseLeads",
      "transactionType": "Charge"
    }
  ],
  "last": "f8cUk/xJkbeYp2L8oHqxL2hFiGz3qjqt",
  "next": "f8cUk/xjhyEYp2L8oHqxL2hFiGz3qjqt",
  "prev": "f8cUk/xJkbeYp2L8oHqxL2hFiGz3qjcc"
}
```

**SDK Code**

```python default
import requests

url = "https://api.shipbob.com/Experimental/invoices/1/transactions"

querystring = {"cursor":"f8cUk/xJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0+BVMffFoIfoqzOkEsAw","pageSize":"100","sortOrder":"Descending"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript default
const url = 'https://api.shipbob.com/Experimental/invoices/1/transactions?cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&pageSize=100&sortOrder=Descending';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go default
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.shipbob.com/Experimental/invoices/1/transactions?cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&pageSize=100&sortOrder=Descending"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby default
require 'uri'
require 'net/http'

url = URI("https://api.shipbob.com/Experimental/invoices/1/transactions?cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&pageSize=100&sortOrder=Descending")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java default
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.shipbob.com/Experimental/invoices/1/transactions?cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&pageSize=100&sortOrder=Descending")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php default
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.shipbob.com/Experimental/invoices/1/transactions?cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&pageSize=100&sortOrder=Descending', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp default
using RestSharp;

var client = new RestClient("https://api.shipbob.com/Experimental/invoices/1/transactions?cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&pageSize=100&sortOrder=Descending");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift default
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.shipbob.com/Experimental/invoices/1/transactions?cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&pageSize=100&sortOrder=Descending")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```